unit RDPoly;
{ *************************************************
  *            FormRgn library 04.05.99           *
  *           written by Grigoriev Anton          *
  *                                               *
  *      Auxiliary unti for property editor       *
  ************************************************* }

 interface

 uses Windows,Messages,SysUtils,Classes,Graphics,Controls,Forms,Dialogs,StdCtrls,ExtCtrls,Buttons,RgnEdit;

  type TPolyEditDlg=class(TForm)
                     ListBox:TListBox;
                     EditX:TEdit;
                     EditY:TEdit;
                     BtnAdd:TBitBtn;
                     BtnDel:TBitBtn;
                     BtnUp:TBitBtn;
                     BtnDown:TBitBtn;
                     RGroupF:TRadioGroup;
                     BtnOK:TBitBtn;
                     BtnCancel:TBitBtn;
                     Label1:TLabel;
                     Label2:TLabel;
                     procedure ListBoxDrawItem(Control:TWinControl;Index:Integer;Rect:TRect;State:TOwnerDrawState);
                     procedure BtnAddClick(Sender:TObject);
                     procedure BtnDelClick(Sender:TObject);
                     procedure BtnUpClick(Sender:TObject);
                     procedure BtnDownClick(Sender:TObject);
                     procedure BtnOKClick(Sender:TObject);
                    public
                     function Execute(SP:string):string;
                   end;

    var PolyEditDlg:TPolyEditDlg;

 implementation

 {$R *.DFM}

  procedure TPolyEditDlg.ListBoxDrawItem(Control:TWinControl;Index:Integer;Rect:TRect;State:TOwnerDrawState);
   var P,M:Integer;
    begin
     with ListBox do
      begin
       Canvas.FillRect(Rect);
       P:=Pos(',',Items[Index]);
       M:=(Rect.Left+Rect.Right) div 2;
       Canvas.TextOut(Rect.Left+3,Rect.Top+1,Copy(Items[Index],1,P-1));
       Canvas.Pen.Style:=psClear;
       Canvas.Rectangle(M-4,Rect.Top,M+4,Rect.Bottom);
       Canvas.Pen.Style:=psSolid;
       Canvas.Pen.Color:=clSilver;
       Canvas.MoveTo(M,Rect.Top);
       Canvas.LineTo(M,Rect.Bottom);
       Canvas.TextOut(M+3,Rect.Top+1,Copy(Items[Index],P+1,MaxInt));
       Canvas.MoveTo(Rect.Left,Rect.Bottom-1);
       Canvas.LineTo(Rect.Right,Rect.Bottom-1)
      end
   end;

  function TPolyEditDlg.Execute;
   var I:Integer;
    begin
     if SP[1]='L' then
      RGroupF.ItemIndex:=0
     else
      RGroupF.ItemIndex:=1;
     Delete(SP,1,1);
     while SP<>'' do
      begin
       I:=Pos(',',SP);
       ListBox.Items.Insert(ListBox.Items.Count-1,Copy(SP,1,I));
       Delete(SP,1,I);
       I:=Pos(',',SP);
       if I=0 then
        begin
         ListBox.Items[ListBox.Items.Count-2]:=ListBox.Items[ListBox.Items.Count-2]+SP;
         SP:=''
        end
       else
        begin
         ListBox.Items[ListBox.Items.Count-2]:=ListBox.Items[ListBox.Items.Count-2]+Copy(SP,1,I-1);
         Delete(SP,1,I)
        end
      end;
     if ShowModal=mrOK then
      begin
       if RGroupF.ItemIndex=0 then
        Result:='L'
       else
        Result:='W';
       for I:=0 to ListBox.Items.Count-2 do
        Result:=Result+ListBox.Items[I]+',';
       Delete(Result,Length(Result),1)
      end
     else
      Result:=''
    end;

  procedure TPolyEditDlg.BtnAddClick(Sender:TObject);
   begin
    if (Owner as TRgnEditDlg).Check(EditX.Text) and (Owner as TRgnEditDlg).Check(EditY.Text) then
     begin
      if ListBox.ItemIndex>=0 then
       ListBox.Items.Insert(ListBox.ItemIndex,UpperCase(EditX.Text)+','+UpperCase(EditY.Text))
      else
       ListBox.Items.Insert(ListBox.Items.Count-1,UpperCase(EditX.Text)+','+UpperCase(EditY.Text))
     end
    else
     ShowMessage('Syntax error in coordiantes')
   end;

  procedure TPolyEditDlg.BtnDelClick(Sender:TObject);
   var P:Integer;
    begin
     with ListBox do
      if (ItemIndex>=0) and (ItemIndex<Items.Count-1) then
       begin
        P:=ItemIndex;
        Items.Delete(P);
        ItemIndex:=P
       end
    end;

  procedure TPolyEditDlg.BtnUpClick(Sender:TObject);
   begin
    with ListBox do
     if (ItemIndex>0) and (ItemIndex<Items.Count-1) then
      begin
       Items.Exchange(ItemIndex,ItemIndex-1);
       ItemIndex:=ItemIndex-1
      end
   end;

  procedure TPolyEditDlg.BtnDownClick(Sender:TObject);
   begin
    with ListBox do
     if (ItemIndex>=0) and (ItemIndex<Items.Count-2) then
      begin
       Items.Exchange(ItemIndex,ItemIndex+1);
       ItemIndex:=ItemIndex+1
      end
   end;

  procedure TPolyEditDlg.BtnOKClick(Sender:TObject);
   begin
    if ListBox.Items.Count>=4 then
     ModalResult:=mrOK
    else
     ShowMessage('It bust be 3 or more points in polygon')
   end;

 end.
